unit Runnen;

{$IFNDEF WIN32}
  ERROR!  This unit only available on Win32!
{$ENDIF}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ShellAPI;

type


  TExec = class(TComponent)
  private

    FName: String;
    FPath: String;
    {FParams: TStringList;}
    Explanation: TStringList;
    FMode: Word;
    FWindowState: TWindowState;
    procedure SetWindowState(AWindowState: TWindowState);

  protected

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Execute;
    procedure Clear;
    procedure SetExplanation(AExpl: TStringList);
  published
    property Uitleg: TStringList read Explanation write SetExplanation;
    property Bestandsnaam: String read FName write FName;
    {property ExeParams: TStringList read FParams write SetExeParams;}
    property WindowState: TWindowState read FWindowState write SetWindowState;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('System', [TExec]);
end;

constructor TExec.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  {FParams := TStringList.Create;}
  Explanation := TStringList.Create;
  Explanation.Add('Uitleg');
  Explanation.Add('Vul in run time of design time de naam inclusief pad van het');
  Explanation.Add('bestand in dat moet worden geopend. Gebruik daarna de methode');
  Explanation.Add('Execute om het bestand te laten zien/horen');
  Explanation.Add('');
  Explanation.Add('Explanation');
  Explanation.Add('Fill in file name including path to be opened at design or run time.');
  Explanation.Add('Then use Execute method to show or listen to chosen file.');
  FMode := SW_SHOWNORMAL;
end;

destructor TExec.Destroy;
begin
  {FParams.Free;}
  inherited Destroy;
end;

procedure TExec.Execute;
var
  FileName, lParam: string;
  {lParam: TStringList;}
  zFileName,zParam: array[0..MAX_PATH] of Char;
begin
  FileName := FName;
  lParam := '';
  ShellExecute(Application.MainForm.Handle, nil,
  StrPCopy(zFileName, FileName),StrPCopy(zParam, lParam), nil, FMode);
 
end;

procedure TExec.SetWindowState(AWindowState: TWindowState);
const
  Mode: array[wsNormal..wsMaximized] of Word =
    (SW_SHOWNORMAL, SW_SHOWMINIMIZED, SW_SHOWMAXIMIZED);
begin
  if FWindowState <> AWindowState then
  begin
    FMode := Mode[AWindowState];
    FWindowState := AWindowState;
  end;
end;

procedure TExec.SetExplanation(AExpl: TStringList);
begin
 Explanation.Assign(AExpl);
end;
{procedure TExec.SetExeParams(AExeParams: TStringList);
begin
  FExeParams.Assign(AExeParams);
end;}

procedure TExec.Clear;
begin
  FName := '';
  {FExeParams.Clear;}
end;


end.
